Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Ink
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports EventNamesHome.ServiceReference1

Namespace EventNamesHome
	' I'm identifying the data for the Pivot Viewer here
	Public Class DemoItem
		Implements INotifyPropertyChanged

		Public Property ShortName As String
		Public Shared _sc As Service1Client
		Public Shared snames As List(Of String) ' List of attendee names
		Public Shared snamescnt As Integer ' how many attendees?

		Private _color As String
		Public Property Color As String
			Get
				Return _color
			End Get
			Set(ByVal value As String)
				_color = value
				NotifyProperty("Color")
			End Set
		End Property

		Private _value As Integer
		Public Property Value As Integer
			Get
				Return _value
			End Get
			Set(ByVal value As Integer)
				_value = value
				NotifyProperty("Value")
			End Set
		End Property

		Private _data1 As String
		Public Property Data1 As String
			Get
				Return _data1
			End Get
			Set(ByVal value As String)
				_data1 = value
				NotifyProperty("Data1")
			End Set
		End Property

		Private _pname As String
		Public Property Pname As String
			Get
				Return _pname
			End Get
			Set(ByVal value As String)
				_pname = value
				NotifyProperty("Pname")
			End Set
		End Property

		Private _stamp As String
		Public Property Stamp As String
			Get
				Return _stamp
			End Get
			Set(ByVal value As String)
				_stamp = value
				NotifyProperty("Stamp")
			End Set
		End Property

		' initialize the async call to the Azure service for Azure data
		Public Shared Sub init()
			_sc = New Service1Client
			AddHandler _sc.MyDataCompleted, AddressOf _sc_MyDataCompleted
			_sc.MyDataAsync(1)
		End Sub

		' When the data returns to the callback here, I'll iterate through each name and parse it into the control
		Public Shared Sub _sc_MyDataCompleted(ByVal sender As Object, ByVal e As MyDataCompletedEventArgs)
			snamescnt = e.Result.Count ' how many attendees?

			snames = New List(Of String) ' put each into the List of strings

			For i  = 0 To snamescnt-2
				snames.Add(e.Result(i).ToString)
			Next i
		End Sub

		Public Shared Function BuildData() As ObservableCollection(Of DemoItem)

			Dim data = New ObservableCollection(Of DemoItem)
			Dim j As Integer = 0

            For Each i In snames
                j += 1

                Dim ss1 As String = (i.Substring(0, i.IndexOf("("c) - 1)).Trim

                Dim itm = New DemoItem With {.ShortName = " " & ss1 & " "}

                ' Parse the attendee names here
                Dim lname() As String = ss1.Split(","c)

                itm.Stamp = "http://markcheckin.cloudapp.net/default.aspx?lname=" & lname(0) & "&fname=" & lname(1)
                itm.Data1 = i.Substring(0, 1).ToUpper

                ' Mod 5 to alternate background tile colors
                Dim [mod] = j Mod 5

                Select Case [mod]
                    Case 0
                        itm.Color = "CornflowerBlue"
                    Case 1
                        itm.Color = "Gold"
                    Case 2
                        itm.Color = "YellowGreen"
                    Case 3
                        itm.Color = "IndianRed"
                    Case 4
                        itm.Color = "Khaki"
                End Select

                data.Add(itm)
            Next i

			Return data
		End Function

		#Region "INotifyPropertyChanged"
		Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

		Public Sub NotifyProperty(ByVal propName As String)
			RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propName))
		End Sub
		#End Region

	End Class
End Namespace
